<template>
	<div class="snapshot-statistics-redo-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<vxe-grid v-bind="gridOptions" ref="gridRef">
				<template #form>
					<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline :disabled="gridOptions.loading">
						<el-form-item prop="crTime">
							<statistical-time v-model="state.queryParams.crTime" @change="handleQuery" ref="statisticalTimeRef" :disabled="state.loading" />
						</el-form-item>
						<el-form-item>
							<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
							<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
								<SvgIcon name="ele-Refresh" class="mr5" />重置
							</el-button>
						</el-form-item>
					</el-form>
				</template>
			</vxe-grid>
		</div>
	</div>
</template>

<script lang="tsx" setup name="snapshotStatisticsRedo">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { defaultDate } from '@/utils/constants';
import { getSSPStatisticsReprocessing, getSSPStatisticsReprocessingExport } from '@/api/snapshot/statistics';
import Other from '@/utils/other';
import { useRouter } from 'vue-router';

// 引入组件
const StatisticalTime = defineAsyncComponent(() => import('@/components/StatisticalTime/index.vue')); // 日期类型选择组件

// 定义变量内容
const state = reactive<any>({
	loading: false,
	queryParams: {
		// 查询参数
		crTime: defaultDate, // 时间默认今天开始到今天结束
		StartTime: null,
		EndTime: null,
	},
});

const requestParams = ref<EmptyObjectType>({});
const gridOptions = reactive<any>({
	loading: false,
	border: true,
	showOverflow: true,
	columnConfig: {
		resizable: true,
	},
	scrollY: {
		enabled: true,
		gt: 100,
	},
	toolbarConfig: {
		zoom: true,
		custom: true,
		refresh: {
			queryMethod: () => {
				handleQuery();
			},
		},
		tools: [{ toolRender: { name: 'exportAll' } }],
	},
	customConfig: {
		storage: true,
	},
	id: 'snapshotStatisticsRedo',
	rowConfig: { isHover: true, height: 30, isCurrent: true, useKey: true },
	height: 'auto',
	align: 'center',
	columns: [],
	data: [],
	params: {
		exportMethod: getSSPStatisticsReprocessingExport,
		exportParams: requestParams,
	},
});
/** 搜索按钮操作 节流操作 */
const handleQuery = () => {
	queryList();
};
// 获取参数列表
const queryList = () => {
	state.loading = true;
	gridOptions.loading = true;
	requestParams.value = Other.deepClone(state.queryParams);
	requestParams.value.StartTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[0]; // 受理时间
	requestParams.value.EndTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[1];
	Reflect.deleteProperty(requestParams.value, 'crTime'); // 删除无用的参数
	getSSPStatisticsReprocessing(requestParams.value)
		.then((res) => {
			let columns = res.result.headers?.map((item: any) => {
				return {
					align: 'center',
					field: item.dicDataValue,
					title: item.dicDataValue,
					slots: {
						default(scope: any) {
							return (
								<el-button type="primary" onClick={() => linkDetail(scope.row, item.dicDataValue)} link>
									{scope.row[item.dicDataValue] ? scope.row[item.dicDataValue] : 0}
								</el-button>
							);
						},
					},
				};
			});
			columns.unshift({
				field: 'OrgName',
				title: '部门名称',
				fixed: 'left',
				minWidth: 120,
			});
			state.loading = false;
			gridOptions.data = res.result?.data ?? [];
			gridOptions.columns = columns;
			gridOptions.loading = false;
		})
		.finally(() => {
			state.loading = false;
			gridOptions.loading = false;
		});
};
// 重置表单
const ruleFormRef = ref<any>(null); // 表单ref
const statisticalTimeRef = ref<RefType>();
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	statisticalTimeRef.value.reset();
	queryList();
};
// 跳转详情
const router = useRouter();
const linkDetail = (row: any, FieldName: string) => {
	router.push({
		path: '/snapshot/statistic/detailRedo',
		query: {
			FieldName,
			OrgCode: row.OrgCode,
			StartTime: state.queryParams.crTime[0],
			EndTime: state.queryParams.crTime[1],
		},
	});
};
// 页面加载时
onMounted(() => {
	queryList();
});
</script>
